/* 
	What's New in SQL Server "Denali"?
	Aaron Bertrand - abertrand@sqlsentry.net
*/     

/* DEMO 1 */
/* metadata discovery of SELSTAR queries */

CREATE TABLE dbo.x
(
	foo     INT PRIMARY KEY,
	bar     DECIMAL(12, 2),
	splunge NVARCHAR(MAX),
	whence  DATETIME2(4) NOT NULL DEFAULT SYSDATETIME()
);

SELECT name, system_type_name, is_nullable
FROM sys.dm_exec_describe_first_result_set
(
	N'SELECT * FROM dbo.x;',
	NULL,
	0
)
ORDER BY column_ordinal;

DROP TABLE dbo.x;


GO

/* DEMO 2 */
/* metadata discovery to support building staging tables */

SET NOCOUNT ON;

SELECT 'CREATE TABLE dbo.DMVStat1(';

SELECT 
	CASE column_ordinal 
		WHEN 1 THEN '' ELSE ',' END 
	+ name + ' ' + system_type_name + CASE is_nullable 
		WHEN 0 THEN ' not null' ELSE '' END
FROM 
	sys.dm_exec_describe_first_result_set
	(
		N'SELECT * FROM sys.dm_exec_sessions;',
		NULL,
		0
	)
ORDER BY column_ordinal;

SELECT ');'

GO

/* DEMO 3 */
/* it does not work for #temp tables */

EXEC sys.sp_describe_first_result_set N'DECLARE @x TABLE(i INT);SELECT i FROM @x;';
EXEC sys.sp_describe_first_result_set N'CREATE TABLE #y (j INT);SELECT j FROM #y;';
GO

/* DEMO 4 */
/* show sniffing of undeclared parameters */

EXEC sys.sp_describe_undeclared_parameters
	@tsql = N'SELECT * FROM sys.objects 
		WHERE [object_id] = @ObjectID
		OR (name LIKE @ObjectName);';
